hdu3853-Loops

LOOPS

Time Limit: 15000/5000 MS (Java/Others)    Memory Limit: 125536/65536 K (Java/Others)
Total Submission(s): 1131    Accepted Submission(s): 465


Problem Description
Akemi Homura is a Mahou Shoujo (Puella Magi/Magical Girl).

Homura wants to help her friend Madoka save the world. But because of the plot of the Boss Incubator, she is trapped in a labyrinth called LOOPS.

The planform of the LOOPS is a rectangle of R*C grids. There is a portal in each grid except the exit grid. It costs Homura 2 magic power to use a portal once. The portal in a grid G(r, c) will send Homura to the grid below G (grid(r+1, c)), the grid on the right of G (grid(r, c+1)), or even G itself at respective probability (How evil the Boss Incubator is)!
At the beginning Homura is in the top left corner of the LOOPS ((1, 1)), and the exit of the labyrinth is in the bottom right corner ((R, C)). Given the probability of transmissions of each portal, your task is help poor Homura calculate the EXPECT magic power she need to escape from the LOOPS.




 

 

Input
The first line contains two integers R and C (2 <= R, C <= 1000).

The following R lines, each contains C*3 real numbers, at 2 decimal places. Every three numbers make a group. The first, second and third number of the cth group of line r represent the probability of transportation to grid (r, c), grid (r, c+1), grid (r+1, c) of the portal in grid (r, c) respectively. Two groups of numbers are separated by 4 spaces.

It is ensured that the sum of three numbers in each group is 1, and the second numbers of the rightmost groups are 0 (as there are no grids on the right of them) while the third numbers of the downmost groups are 0 (as there are no grids below them).

You may ignore the last three numbers of the input data. They are printed just for looking neat.

The answer is ensured no greater than 1000000.

Terminal at EOF


 

 

Output
A real number at 3 decimal places (round to), representing the expect magic power Homura need to escape from the LOOPS.

 

 

Sample Input
2 2 0.00 0.50 0.50 0.50 0.00 0.50 0.50 0.50 0.00 1.00 0.00 0.00
 

 

Sample Output
6.000
 

 地址:http://acm.hdu.edu.cn/showproblem.php?pid=3853

概率dp:

一个方格矩阵r*c,现在从(1,1)走到(r,c),假设当前走到的格子为(i,j),停留原地概率为p1[i][j],下一次移动到格子(i,j+1)概率为p2[i][j],到(i+1,j)概率为p3[i][j]。p1[i][j]+p2[i][j]+p3[i][j]=1。三者需要消耗的能量均为2,问走到(r,c)需要消耗的能量 不妨跟之前的DP一样的解法试试。 假设从当前格子为(i,j)走到(r,c)需要消耗的能量为dp[i][j] dp[i][j] = p1[i][j]*dp[i][j]+p2[i][j]*dp[i][j+1]+p3[i][j]*dp[i+1][j]+2 这时两边都有dp[i][j],移项,dp[i][j]就可求了。 概率为1的时候需要注意一下(把学长的ppt的话粘下来的)

要注意的是dp[i][j]=p2[i][j]/(1-p1[i][j])*dp[i][j+1]+p3[i][j]/(1-p1[i][j])*dp[i+1][j]+2/(1-p1[i][j]);这个方程,如果先算加法最后除以(1-p1[i][j])的话会超时,一定要每步除一次,还有注意p1[i][j]!=1........................

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <vector>
#include <queue>
#include <algorithm>
#define LL long long
#define M 1010
using namespace std;
int r,c;
double p1[M][M],p2[M][M],p3[M][M],dp[M][M];
int main()
{
    while(scanf("%d%d",&r,&c)!=EOF){
        for(int i=1;i<=r;i++)
            for(int j=1;j<=c;j++)
                scanf("%lf%lf%lf",&p1[i][j],&p2[i][j],&p3[i][j]);
        dp[r][c]=0;
        for(int i=r;i>=1;i--)
            for(int j=c;j>=1;j--){
                if(fabs(1-p1[i][j])<1e-5)continue;
                if(!(i==r&&j==c))
                    dp[i][j]=p2[i][j]/(1-p1[i][j])*dp[i][j+1]+p3[i][j]/(1-p1[i][j])*dp[i+1][j]+2/(1-p1[i][j]);
            }
        printf("%.3lf\n",dp[1][1]);
    }
    return 0;
}
View Code

 

 

 

posted @ 2013-08-14 14:37  SunnySnail  阅读(197)  评论(0编辑  收藏  举报